/**************************************************************** 
GensubDVG ver 2.0 by Marco Quaranta
Main module of a Distributed Valent Graph-Subgraph Generator
that create a DVG and its subgraph
saving them into 2 files using vf file format.
*****************************************************************/
#include<iostream>
#include<math.h>
#include<time.h>
#include<stdlib.h>
#include<stdio.h>
#include<strstream>
#include<fstream>

#define NODEMX 65535
#define ALPHA 0.5

// macro for printing matrix "mt" on screen
#define MATOUT(mt) { for (int xcnt=0; xcnt<Nmax; xcnt++) \
			{for (int ycnt=0; ycnt<Nmax; ycnt++) \
		           cout<<mt[xcnt][ycnt]<<" "; \
			cout<<endl; \
		}; cout<<endl;  \
	}       

void Wordwrite(ofstream &data, int nmb)
{   unsigned short mask=255;
    char msb,lsb;
    lsb=nmb>>8;
    msb=nmb&mask;
    data.write(&msb, sizeof(msb));
    data.write(&lsb, sizeof(lsb));
}    

// node-exchange to build a new matrix 
int nodemx(int *snode, int Nmax)
{ 



  for(int it=0; it<Nmax; it++)
         snode[it]=it;
  for(int it=0; it<Nmax; it++)
          { int tmp;
            int j;
	    j=(int)floor(rand()/(float)RAND_MAX*Nmax);
            tmp=snode[j];
            snode[j]=snode[it];
            snode[it]=tmp;
          };
}

// move current edge to a new target
int nodin(int b, int n, int oldpos) 
{ static int Noutbound=0;
  static int outbnd=0;
  double r,l,x,nod,c;
  c=(int)(floor)(ALPHA*sqrt(n));
if (b<=c)
   {cout<<"WARNING min #node2move must be >="<<c+1<<endl;
    cout<<"forcing target node..."<<endl;
    if (!outbnd)      
    {// on error: choosing the one & only target 
	if (oldpos>=n)
	    Noutbound=oldpos-1;
	else
    	    Noutbound=oldpos+1;
     };
     outbnd=1;	 	
     nod=Noutbound;
    } 
else    
 {do {
      // function to use as distribution
      r=(rand()/(float)RAND_MAX);
      l=-n*log(1-((ALPHA*sqrt(n))/b));
      x=-(log(1-r))/l;
      nod=(int)floor(x*n);}
  while (nod>=n|nod<0);};
return (int)nod;
}

int main(int argc, char* argv[]) 
{ 

if (argc!=6)
    {cout<<"Usage:"<<endl;
     cout<<"gensubbvg SubNodes Nodes Valence subfname bvgfname"<<endl;
    return 1;};

#ifdef PORTABLE_SEED_INIT
    srand(time(NULL));
#else
    { FILE *urand=fopen("/dev/urandom", "rb");
      unsigned int seed;
      fread(&seed, sizeof(seed), 1, urand);
      fclose(urand);
      srand(seed);
    }
#endif

int Nsub=atoi(argv[1]);
int Nmax=atoi(argv[2]);
int vz=atoi(argv[3]);
int movnod=0;
char *fname1=argv[4];
char *fname2=argv[5];
ofstream bindata1(fname2);
ofstream bindata2(fname1);
bindata1.setf(ios::out|ios::binary);
bindata2.setf(ios::out|ios::binary);

if (Nsub>Nmax)
	{ cout<<endl<<"WARNING - out of subnode bounds"<<endl;
	  cout<<"Number of subgraph nodes must be <="<<Nmax<<endl;
	return 1;
};

if (Nmax>NODEMX)
	{ cout<<endl<<"WARNING - Out of MAX_#nodes bound"<<endl;
 	  cout<<"#nodes must be <="<<NODEMX<<endl;
	return 1;
};

int a[Nmax][Nmax];
int b[Nmax][Nmax];
int r[Nmax];
int c[Nmax];
int vis[Nmax];
int snode[Nmax];
int ncount[Nmax];
int i,j;
int vdisp=0;
int ndisp=0;

int h=1;
int idx,ora,inl,cor;
int trovato=0;
int row,col,rpos,cpos;


if (vz<=1)
	{ cout<<endl<<"WARNING - Valence="<<vz<<" is too small"<<endl;
 	  cout<<"Valence must be >="<<2<<endl;
	return 1;
};


//initialize matrix     
    for (i=0; i<Nmax; i++)
      {for (j=0; j<Nmax; j++)
          { if(i>=j)  { a[i][j]=0;
	    b[i][j]=0;}
           else
    	    {a[i][j]=1;
	     b[i][j]=0;
	    };
          };
	  ncount[i]=0;
      };

//valence induced fault ------------
// a[0][0]=123;
//----------------------------------

//valence bound check
int modulo;
float restov=0,reston=0;
modulo=vz/2;
restov=vz%2;
reston=Nmax%2;

if (vz>=Nmax)
	{ cout<<endl<<"WARNING - Out of Valence Bound"<<endl;
 	  cout<<"Valence must be <="<<Nmax-1<<endl;
	return 1;
};

//valence parity check
if (restov!=0) 
{       vdisp=1;
	if (reston!=0) 
	{ cout<<endl<<"WARNING - Unable to generate a DVG" <<endl;
	cout<<"with both Valence & #nodes-parity odd"<<endl;
	--vz;
	cout<<"Valence could be="<<vz<<endl;
	return 1;};
};
if(reston!=0)
        ndisp=1;
if(vdisp)
	vz--;

//-----------generate the canon matrix ---------------
// #nodes parity=odd & valence parity=even    
if(ndisp)
{
    int med=Nmax/2;
    int k,x,y;

    k=((Nmax-vz)/2)-1;
    x=med-k;
    y=med+k+1;

    int q=0;
    int h=x;
    int z=y;
    while (h<=y) 
    {	
        while(q<z)
	{  a[q][q+h]=0;
	   q++;
	} ;
    h++;
    z--;
    q=0;	
    };
}
else
{
// #nodes parity=even & valence parity=even    
    int med=Nmax/2;
    int k,x,y;

    k=((Nmax-vz)/2)-1;
    x=med-k;
    y=med+k;

    int q=0;
    int h=x;
    int z=y;
    while (h<=y) 
    {	
        while(q<z)
	{  a[q][q+h]=0;
	   q++;
	} ;
    h++;
    z--;
    q=0;	
};

// #nodes parity=even & valence parity=odd    
if(vdisp)
{
     for (int u=0; u<med; u++)
	{ a[u][u+med]=1;
	};
     vz++;    
 };

};

//-----------random edge_moving
int lift=0;
for (int i=0; i<Nmax; i++)
{ for (int j=0; j<Nmax; j++)
    { if (j>i)
	{ if (a[i][j]==1)
	     { lift=(int)floor(rand()/(float)RAND_MAX*2);
	       if (lift==1)
	           {a[i][j]=0;
		    a[j][i]=1;    
	           };
             };
	};       
     };
};


//rows & cols check 
int vsum=0;
    for (int w=0; w<Nmax; w++)
        {for (int o=0; o<Nmax; o++)
	        vsum=vsum+a[w][o]+a[o][w];
         if (vsum!=vz)
	     { cout<<endl<<"WARNING - Failed to Generate a DVG"<<endl;
	     return 1;};
	 vsum=0;
	};

// exchanging node to build a new matrix 
nodemx(snode,Nmax);

//copy A_canon_matrix into B_working_matrix
for (int i=0; i<Nmax; i++) 
     {for (int j=0; j<Nmax; j++) 
          { b[i][j]=a[snode[i]][snode[j]]; 
	   } 
       } 

//--------------------------begin moving edges
int movrow=0,movcol=0,nodest=0,fifth=0;
int count=movnod;
while(count>0)
    {movrow=(int)floor(rand()/(float)RAND_MAX*Nmax);
     movcol=(int)floor(rand()/(float)RAND_MAX*Nmax);
     if (b[movrow][movcol]==1)
         { nodest=nodin(movnod,Nmax,movcol);
//choosing at 50% if moving a row or a col-------------------
	   if(!fifth)
	       {if (b[movrow][nodest]==0&nodest!=movrow)
		      { b[movrow][movcol]=0;
    	    		b[movrow][nodest]=2;
		        count--;
	               };
                 fifth=1;
		}
	   else	 
	          {if (b[nodest][movcol]==0&nodest!=movcol)
		      { b[movrow][movcol]=0;
    	    		b[nodest][movcol]=2;
		        count--;
	               };
		 fifth=0;
		};      
	 };
     };

//MATOUT(b);

//renaming new edges from 2 to 1
for (int i=0; i<Nmax; i++) 
     {for (int j=0; j<Nmax; j++) 
            if (b[i][j]==2)
		    b[i][j]=1;
     };

//MATOUT(b);
//counting #edges for each node
for (int i=0; i<Nmax; i++) 
     {for (int j=0; j<Nmax; j++) 
            ncount[i]+=b[i][j];
     };

// create DVG file1
Wordwrite(bindata1,Nmax);
    for (int i=0; i<Nmax; i++)
       { Wordwrite(bindata1,ncount[i]);
         ncount[i]=0; 
         for (int j=0; j<Nmax; j++)
          { if (b[i][j]==1)
	      Wordwrite(bindata1,j);
	  };
    };

// exchanging node to build a new matrix 
nodemx(snode,Nmax);

//copy B_working_matrix into A_new_working_matrix
for (int i=0; i<Nmax; i++) 
     {for (int j=0; j<Nmax; j++) 
           a[i][j]=b[snode[i]][snode[j]]; 
     } 

//MATOUT(a);

//*********************************************************

for (i=0; i<Nmax;i++)
	 vis[i]=0;

trovato=0;
vis[0]=0;

idx=0;
inl=0;
cor=0;
ora=cor;

while(idx<Nsub)
{
for (j=0; j<Nmax;j++)
{
	 if (b[ora][j]==1)
	       { rpos=j;
	         trovato=1;
	       }

if (trovato==1)
   {trovato=0;
    for(i=0; i<idx; i++)
	if (vis[i]==rpos) inl=1;
    if (inl==0)
         {idx++;
	  vis[idx]=rpos;
	 }
    else
       inl=0;
   };//end if
};//end for j

for (j=0; j<Nmax;j++)
{
	 if (b[j][ora]==1)
	       { rpos=j;
	         trovato=1;
	       }

if (trovato==1)
   {trovato=0;
    for(i=0; i<idx; i++)
	if (vis[i]==rpos) inl=1;
    if (inl==0)
         {idx++;
	  vis[idx]=rpos;
	 }
    else
       inl=0;
   };//end if
};//end for j
cor++;
ora=vis[cor];
//exit(1);
}; //end while 

//for (i=0; i<Nsub; i++)
//   cout<<vis[i]<<endl;

h=0;
i=0;
while (h<Nsub)
{
    {for (j=0; j<Nsub;j++)    	
	     a[h][j]=b[vis[i]][vis[j]];
     h++;
     i++;	  
    }
};   


//************************************************************

//simple nodes subtracting
Nmax=Nsub;

//MATOUT(a);
//counting #edges for each node
for (int i=0; i<Nmax; i++) 
     {for (int j=0; j<Nmax; j++) 
            ncount[i]+=a[i][j];
     };

// create DVG file2
Wordwrite(bindata2,Nmax);
    for (int i=0; i<Nmax; i++)
       { Wordwrite(bindata2,ncount[i]);
         for (int j=0; j<Nmax; j++)
          { if (a[i][j]==1)
	     Wordwrite(bindata2,j);
	  };
    };
}
