/**************************************************************** 
Gensubm4D ver 3.0 by Marco Quaranta
Main module of a 4D Mesh-Submesh Generator
that create into files two isomorph 4DMesh-4DsubMesh
using vf file format.
*****************************************************************/
#include<math.h>
#include<time.h>
#include<stdlib.h>
#include<stdio.h>
#include<iostream>
#include<strstream>
#include<fstream>

#define NODEMX 65535
#define DIM 4

// macro for printing matrix "mt" on screen
#define MATOUT(mt) { for (int xcnt=0; xcnt<bigside; xcnt++) \
			{for (int ycnt=0; ycnt<bigside; ycnt++) \
		           cout<<mt[xcnt][ycnt]; \
			cout<<xcnt<<": "<<endl; \
		}; cout<<endl;  \
	}       

float root(float num)
{ float radc;
  float pot=DIM;
  radc=1/pot;  
  return pow(num,radc);
}

void Wordwrite(ofstream &data, int nmb)
{   unsigned short mask=255;
    char msb,lsb;
    lsb=nmb>>8;
    msb=nmb&mask;
    data.write(&msb, sizeof(msb));
    data.write(&lsb, sizeof(lsb));
}    

// node-exchange to build a new matrix 
int nodemx(short int *snode, int Ndmax)
{ 



  for(int it=0; it<Ndmax; it++)
         snode[it]=it;
  for(int it=0; it<Ndmax; it++)
          { int tmp;
            int j;
	    j=(int)floor(rand()/(float)RAND_MAX*Ndmax);
            tmp=snode[j];
            snode[j]=snode[it];
            snode[it]=tmp;
          };
}


int main(int argc, char* argv[]) 
{ 
#ifdef PORTABLE_SEED_INIT
    srand(time(NULL));
#else
    { FILE *urand=fopen("/dev/urandom", "rb");
      unsigned int seed;
      fread(&seed, sizeof(seed), 1, urand);
      fclose(urand);
      srand(seed);
    }
#endif  

if (argc!=6)
    {cout<<"Usage: gensubm4D SubNodes Nodes extra_edges subfname graphfname"<<endl;
    return 1;};

int Nsub=atoi(argv[1]);
int Nmax=atoi(argv[2]);
int xtredg=atoi(argv[3]);
char *fname1=argv[4];
char *fname2=argv[5];

ofstream bindata1(fname2);
ofstream bindata2(fname1);
bindata1.setf(ios::out|ios::binary);
bindata2.setf(ios::out|ios::binary);


if (Nmax>NODEMX|Nmax<8)
	{ int k=(int)pow(2,DIM);
	  cout<<endl<<"WARNING - out of node bounds"<<endl;
	  cout<<"Number of node must be in ("<<k<<","<<NODEMX<<")"<<endl;
	return 1;
};

float sd;
int side;

sd=root(Nmax);
side=(int)floor(sd);

int nmx,dif;
nmx=(int)pow(side,DIM);
dif=Nmax-nmx;

if (dif>0)
   {cout<<"!!! WARNING !!! Unable to create a 4Dmesh with "<<Nmax<<" nodes"<<endl;
    cout<<"forcing mesh4D creation with "<<nmx<<" nodes..."<<endl;
    Nmax=nmx;
   };

if (Nsub>Nmax)
	{ cout<<endl<<"WARNING - out of subnode bounds"<<endl;
	  cout<<"Number of subgraph nodes must be <="<<Nmax<<endl;
	return 1;
};

int fixedges,filledges,efixed3d,efixed2d;

efixed2d=2*side*(side-1);
efixed3d=(side*side)*(side-1)+(side*efixed2d);
fixedges=(2*efixed3d)+(int)pow(side,DIM-1);

int bigside; 
bigside=(int)pow(side,DIM);

filledges=(bigside*bigside)-fixedges-bigside;

if (xtredg>filledges)
   {cout<<"!!! WARNING !!! Unable to create a 4dmesh with "<<xtredg<<" edges"<<endl;
    cout<<"forcing mesh4D creation with "<<filledges<<" edges..."<<endl;
    xtredg=filledges;
   };

short a[bigside][bigside];

short b[bigside][bigside];

short snode[bigside];

short ncount[bigside];

int i,j,n1,n2;


int idx,ora,inl,cor;
int trovato=0;
int row,col,rpos,cpos;
int vis[bigside];

//initializing matrix & vectors    
    for (i=0; i<bigside; i++)
      { ncount[i]=0;
        snode[i]=0;
      for (j=0; j<bigside; j++)
	        {   a[i][j]=0;
		    b[i][j]=0;
		};
      }; 


//generating canon 4Dmesh 
int qside,dside,mside,h,g;

for (g=0; g<side; g++) 
  for (h=0; h<side; h++) 
    {for (i=0; i<side; i++)
      for (j=0; j<side; j++)
	{ n1=j+(i*side)+(side*side*h)+(side*side*side*g);
             if(j<side-1)
		     {
		      a[n1][n1+1]=1;
		     };
	     if(i<side-1)
	    	     {
		      a[n1][n1+side]=1;
    		     };
		     
	 };  //end for j	     
	}; //end for h
//	}; //edn for g
i=0;
j=0;
dside=(int)pow(side,DIM-1);
mside=(int)pow(side,DIM-2);
qside=side*side*(side-1);
i=0;
j=0;
      do
      {  if (i<qside)
		 {a[i][j+qside]=1; 
		  a[i+dside][j+bigside-qside]=1;}; 
          		 
	  i++,j++;
      } while(i<(bigside-dside)); 

int stp=0;
for (j=0; j<side;j++)
    {	stp=j*dside;
	for (i=stp; i<(stp+qside);i++)
	    a[i][i+mside]=1;
    }; 

//MATOUT(a); 

// creating extra edges



    for (i=0; i<xtredg; i++)
	{
	do {n1=(int)floor(rand()/(float)RAND_MAX*bigside);
            n2=(int)floor(rand()/(float)RAND_MAX*bigside);
	   }while (n1==n2||a[n1][n2]==1); 
	a[n1][n2]=1;   
	}; 


// exchanging node to build a new matrix 
nodemx(snode,bigside);

//copy A_canon_matrix into B_working_matrix
for (int i=0; i<bigside; i++) 
     {for (int j=0; j<bigside; j++) 
          { b[i][j]=a[snode[i]][snode[j]]; 
	   } 
       } 

//MATOUT(b);   

//counting #edges for each node
for (int i=0; i<bigside; i++) 
     {for (int j=0; j<bigside; j++) 
            {ncount[i]+=b[i][j];
	    //cout<<i<<" "<<ncount[i]<<endl;
	    };
     };

// create 4DM file1
Wordwrite(bindata1,bigside);
//cout <<"bigside="<<bigside<<endl;

    for (int i=0; i<bigside; i++)
       { Wordwrite(bindata1,ncount[i]);
         ncount[i]=0; 
         for (int j=0; j<bigside; j++)
          { if (b[i][j]==1)
	      Wordwrite(bindata1,j);
	  };
    };

// exchanging node to build a new matrix 
nodemx(snode,bigside);

//copy B_working_matrix into A_new_working_matrix
for (int i=0; i<bigside; i++) 
     {for (int j=0; j<bigside; j++) 
           a[i][j]=b[snode[i]][snode[j]]; 
     } 

//********************************************************

h=1;

for (i=0; i<bigside;i++)
	 vis[i]=0;

trovato=0;
vis[0]=0;

idx=0;
inl=0;
cor=0;
ora=cor;

while(idx<Nsub)
{
for (j=0; j<bigside;j++)
{
	 if (b[ora][j]==1)
	       { rpos=j;
	         trovato=1;
	       }

if (trovato==1)
   {trovato=0;
    for(i=0; i<idx; i++)
	if (vis[i]==rpos) inl=1;
    if (inl==0)
         {idx++;
	  vis[idx]=rpos;
	 }
    else
       inl=0;
   };//end if
};//end for j

for (j=0; j<bigside;j++)
{
	 if (b[j][ora]==1)
	       { rpos=j;
	         trovato=1;
	       }

if (trovato==1)
   {trovato=0;
    for(i=0; i<idx; i++)
	if (vis[i]==rpos) inl=1;
    if (inl==0)
         {idx++;
	  vis[idx]=rpos;
	 }
    else
       inl=0;
   };//end if
};//end for j
cor++;
ora=vis[cor];
//exit(1);
}; //end while 

//for (i=0; i<Nsub; i++)
//   cout<<vis[i]<<endl;

h=0;
i=0;
while (h<Nsub)
{
    {for (j=0; j<Nsub;j++)    	
	     a[h][j]=b[vis[i]][vis[j]];
     h++;
     i++;	  
    }
};   


//********************************************************
//simple nodes subtracting
bigside=Nsub;

//MATOUT(a);

//counting #edges for each node
for (int i=0; i<bigside; i++) 
     {for (int j=0; j<bigside; j++) 
            ncount[i]+=a[i][j];
     };

// create 4DM file2
Wordwrite(bindata2,bigside);
    for (int i=0; i<bigside; i++)
       { Wordwrite(bindata2,ncount[i]);
         for (int j=0; j<bigside; j++)
          { if (a[i][j]==1)
	     Wordwrite(bindata2,j);
	  };
    };

} 


